;========================== affiche un rectangle plein ==============================
;								appel par CALL
; entres: A=couleur ->  0:blanche  1:noire  2:XOR
;			pb_xg,pb_xd,pb_yh,pb_yb : coordonnes de la case
;		ATTENTION : pb_xg<pb_xd+8		pb_yh<pb_yb
; sorties: rectangle plein affich en $fc00h
;
pbox:
	ld (a_tmp3_pbox),a
	ld a,d \ ld (pb_xg),a
	ld a,e \ ld (pb_yh),a
	ld a,h \ ld (pb_xd),a
	ld a,l \ ld (pb_yb),a
; effacement du cot gauche
	ld a,(pb_xg) \ ld e,a
	ld a,(pb_yh) \ ld d,a
	call FindPixel
	ld (a_sav_rp),a
	ld a,h \ ld (h_tmp1_pbox),a
	ld a,l \ ld (l_tmp1_pbox),a
	ld a,(a_sav_rp)

	ld b,a \ scf \ ccf \ rra \ or b
	ld b,a \ scf \ ccf \ rra \ or b
	ld b,a \ scf \ ccf \ rra \ or b
	ld b,a \ scf \ ccf \ rra \ or b
	ld b,a \ scf \ ccf \ rra \ or b
	ld b,a \ scf \ ccf \ rra \ or b
	ld b,a \ scf \ ccf \ rra \ or b
	ld (a_tmp1_pbox),a

	ld a,(pb_yh) \ ld b,a
	ld a,(pb_yb) \ inc a \ sub b
	ld de,16
	ld (a_tmp2_pbox),a
	ld b,a							; B = cart entre (pb_yh) et (pb_yb)
rec_pbox_vert_g:
	ld a,(a_tmp3_pbox)				; A = mode
	cp 2 \ jr z,mode_g_2
	cp 1 \ jr z,mode_g_1
;mode_g_0
	ld a,(a_tmp1_pbox)
	xor 255
	and (hl)
	jr mode_g_fin
mode_g_1:
	ld a,(a_tmp1_pbox)
	or (hl)
	jr mode_g_fin
mode_g_2:
	ld a,(a_tmp1_pbox)
	xor (hl)
mode_g_fin:
	ld (hl),a
	add hl,de
	djnz rec_pbox_vert_g

; effacement du cot droit
	ld a,(pb_xd) \ ld e,a
	ld a,(pb_yh) \ ld d,a
	call FindPixel

	ld b,a \ scf \ ccf \ rla \ or b
	ld b,a \ scf \ ccf \ rla \ or b
	ld b,a \ scf \ ccf \ rla \ or b
	ld b,a \ scf \ ccf \ rla \ or b
	ld b,a \ scf \ ccf \ rla \ or b
	ld b,a \ scf \ ccf \ rla \ or b
	ld b,a \ scf \ ccf \ rla \ or b
	ld (a_tmp1_pbox),a

	ld a,(a_tmp2_pbox) \ ld b,a		; B = cart entre (pb_yh) et (pb_yb)
	ld de,16
rec_pbox_vert_d:
	ld a,(a_tmp3_pbox)				; A = mode
	cp 2 \ jr z,mode_d_2
	cp 1 \ jr z,mode_d_1
;mode_d_0
	ld a,(a_tmp1_pbox)
	xor 255
	and (hl)
	jr mode_d_fin
mode_d_1:
	ld a,(a_tmp1_pbox)
	or (hl)
	jr mode_d_fin
mode_d_2:
	ld a,(a_tmp1_pbox)
	xor (hl)
mode_d_fin:
	ld (hl),a
	add hl,de
	djnz rec_pbox_vert_d

; effacement du milieu
	ld a,(pb_xd) \ ld e,a				; coin haut-droit
	ld a,(pb_yh) \ ld d,a				;
	call FindPixel					;
	dec hl
	ld a,h \ ld (h_tmp2_pbox),a		; adresse de l'octet contenant le point H-D
	ld a,l \ ld (l_tmp2_pbox),a		;	dans (tmp1_fen) et (tmp2_fen)

	ld a,(h_tmp1_pbox) \ ld h,a		; HL = adresse de l'octet contenant le point H-G
	ld a,(l_tmp1_pbox) \ ld l,a		;

rec_pbox1:
	inc hl							; on passe  l'octet suivant
	ld a,h \ ld (h_tmp1_pbox),a		; on sauve HL
	ld a,l \ ld (l_tmp1_pbox),a		;

	ld a,(a_tmp2_pbox) \ ld b,a		; B = cart entre (pb_yh) et (pb_yb)
	ld de,16
rec_pbox2:
	ld a,(a_tmp3_pbox)				; A = mode
	cp 2 \ jr z,mode_m_2
	cp 1 \ jr z,mode_m_1
;mode_m_0
	ld (hl),0
	jr mode_m_fin
mode_m_1:
	ld (hl),255
	jr mode_m_fin
mode_m_2:
	ld a,(hl)
	xor 255
	ld (hl),a
mode_m_fin:
	add hl,de
	djnz rec_pbox2

	ld a,(h_tmp1_pbox) \ ld h,a		; restaure HL
	ld a,(l_tmp1_pbox) \ ld l,a		;

	ld a,(h_tmp2_pbox) \ cp h \ jr nz,rec_pbox1
	ld a,(l_tmp2_pbox) \ cp l \ jr nz,rec_pbox1

	ret

a_tmp1_pbox: .db 0
a_tmp2_pbox: .db 0
a_tmp3_pbox: .db 0
h_tmp1_pbox: .db 0
l_tmp1_pbox: .db 0
h_tmp2_pbox: .db 0
l_tmp2_pbox: .db 0

a_sav_rp: .db 0

pb_xg: .db 0
pb_xd: .db 0
pb_yh: .db 0
pb_yb: .db 0
;------------------------------------------------------------------------------------
